import React from 'react';
import { SafeAreaView, ActivityIndicator as ActivityIndicator$1 } from 'react-native';
import Config from '../../services/config.js';
import styles from './styles.js';

/**
 * Important for this component is a container with "position: relative"
 */
var ActivityIndicator = function ActivityIndicator(_ref) {
  var _Config$get, _Config$get2;
  var _ref$isFetching = _ref.isFetching,
    isFetching = _ref$isFetching === void 0 ? false : _ref$isFetching,
    color = _ref.color,
    backgroundColor = _ref.backgroundColor,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? 'large' : _ref$size,
    _ref$isTransparent = _ref.isTransparent,
    isTransparent = _ref$isTransparent === void 0 ? false : _ref$isTransparent;
  if (!isFetching) {
    return null;
  }
  var usedColor = color !== null && color !== void 0 ? color : (_Config$get = Config.get('indicators')) === null || _Config$get === void 0 || (_Config$get = _Config$get.activity) === null || _Config$get === void 0 ? void 0 : _Config$get.color;
  var usedBackgroundColor = backgroundColor !== null && backgroundColor !== void 0 ? backgroundColor : (_Config$get2 = Config.get('indicators')) === null || _Config$get2 === void 0 || (_Config$get2 = _Config$get2.activity) === null || _Config$get2 === void 0 ? void 0 : _Config$get2.backgroundColor;
  return /*#__PURE__*/React.createElement(SafeAreaView, {
    style: [styles.wrapperIndicator, isTransparent && styles.wrapperIndicatorTransparent, Boolean(usedBackgroundColor) && {
      backgroundColor: backgroundColor
    }]
  }, /*#__PURE__*/React.createElement(ActivityIndicator$1, {
    style: styles.indicator,
    color: usedColor,
    size: size
  }));
};

export { ActivityIndicator as default };
//# sourceMappingURL=index.js.map
