import { inherits as _inherits, createSuper as _createSuper, createClass as _createClass, classCallCheck as _classCallCheck, defineProperty as _defineProperty, assertThisInitialized as _assertThisInitialized, objectSpread2 as _objectSpread2 } from '../../_virtual/_rollupPluginBabelHelpers.js';
import React, { Component } from 'react';
import { withTranslation } from 'react-i18next';
import { View, Text, Button } from 'react-native';
import CodePush from 'react-native-code-push';
import Config from '../../services/config.js';
import styles from './styles.js';

var ErrorBoundary = /*#__PURE__*/function (_Component) {
  _inherits(ErrorBoundary, _Component);
  var _super = _createSuper(ErrorBoundary);
  function ErrorBoundary() {
    var _this;
    _classCallCheck(this, ErrorBoundary);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {
      hasError: false
    });
    /**
     * Reload app
     */
    _defineProperty(_assertThisInitialized(_this), "handleReloadApp", function () {
      CodePush.restartApp();
    });
    return _this;
  }
  _createClass(ErrorBoundary, [{
    key: "componentDidCatch",
    value:
    /**
     * Handle app errors
     */
    function componentDidCatch(e, errorInfo) {
      var _Config$get;
      (_Config$get = Config.get('logger')) === null || _Config$get === void 0 || _Config$get.error("React DOM error: ".concat(e.message), _objectSpread2(_objectSpread2({}, e), errorInfo));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        children = _this$props.children,
        t = _this$props.t;
      var hasError = this.state.hasError;
      if (hasError) {
        return /*#__PURE__*/React.createElement(View, {
          style: styles.container
        }, /*#__PURE__*/React.createElement(Text, {
          style: styles.text
        }, t('somethingWrong')), /*#__PURE__*/React.createElement(Button, {
          title: t('reloadApp'),
          onPress: this.handleReloadApp
        }));
      }
      return children;
    }
  }], [{
    key: "getDerivedStateFromError",
    value: function getDerivedStateFromError() {
      // Show emergency UI
      return {
        hasError: true
      };
    }
  }]);
  return ErrorBoundary;
}(Component);
var index = withTranslation()(ErrorBoundary);

export { index as default };
//# sourceMappingURL=index.js.map
