import { ReplaceReturnType } from '@lomray/client-helpers/interfaces';
import { ComponentType, ReactElement, Ref } from 'react';
import { FlatListProps, ImageSourcePropType } from 'react-native';
import { AnimatedProps } from 'react-native-reanimated';
interface IFlatList<TEntity = Record<string, any>> extends AnimatedProps<FlatListProps<TEntity>> {
    hasLayoutAnimation?: boolean;
    emptyListTitle?: string;
    emptyListText?: string;
    emptyListImg?: ImageSourcePropType;
    totalEntities?: number;
    isFetching?: boolean;
    isFirstRender?: boolean;
    placeholderCount?: number;
    placeholderContainerStyle?: AnimatedProps<any>['style'];
    EmptyComponent?: ReactElement | false;
    PlaceholderComponent?: ReactElement | ComponentType;
    onRefresh?: ReplaceReturnType<NonNullable<FlatListProps<TEntity>['onRefresh']>, Promise<any>> | FlatListProps<TEntity>['onRefresh'];
    onEndReached?: FlatListProps<TEntity>['onEndReached'];
    onEndReachedAsync?: () => Promise<any> | undefined | void;
}
declare const _default: <TEntity, TRef>(p: IFlatList<TEntity> & {
    ref?: Ref<TRef> | undefined;
}) => ReactElement;
export { _default as default, IFlatList };
