import { FCC } from '@lomray/client-helpers/interfaces';
import { ComponentType, ReactElement } from 'react';
import Animated from 'react-native-reanimated';
interface IPlaceholder {
    isFetching: boolean;
    isFirstRender?: boolean | null;
    count?: number;
    containerStyle?: Animated.AnimateProps<any>['style'];
    PlaceholderComponent?: ReactElement | ComponentType;
}
/**
 * General placeholder
 * 1. Show placeholder while fetching
 * 2. Show component when fetching has done (optional)
 * NOTE: isFirstRender in generally used for flat lists
 * @constructor
 */
declare const Frame: FCC<IPlaceholder>;
export { Frame as default };
