import { toConsumableArray as _toConsumableArray } from '../../../_virtual/_rollupPluginBabelHelpers.js';
import React from 'react';
import Animated, { FadeOut, FadeIn } from 'react-native-reanimated';

/**
 * General placeholder
 * 1. Show placeholder while fetching
 * 2. Show component when fetching has done (optional)
 * NOTE: isFirstRender in generally used for flat lists
 * @constructor
 */
var Frame = function Frame(_ref) {
  var isFetching = _ref.isFetching,
    PlaceholderComponent = _ref.PlaceholderComponent,
    children = _ref.children,
    containerStyle = _ref.containerStyle,
    _ref$isFirstRender = _ref.isFirstRender,
    isFirstRender = _ref$isFirstRender === void 0 ? null : _ref$isFirstRender,
    _ref$count = _ref.count,
    count = _ref$count === void 0 ? 1 : _ref$count;
  return /*#__PURE__*/React.createElement(React.Fragment, null, (isFirstRender === null || isFirstRender === true) && isFetching && PlaceholderComponent !== undefined && /*#__PURE__*/React.createElement(Animated.View, {
    exiting: FadeOut,
    style: containerStyle
  }, _toConsumableArray(Array(count)).map(function (_, i) {
    return /*#__PURE__*/React.createElement(React.Fragment, {
      key: i
    }, /*#__PURE__*/React.isValidElement(PlaceholderComponent) ? PlaceholderComponent : /*#__PURE__*/React.createElement(PlaceholderComponent, null));
  })), (isFirstRender === false || isFirstRender === null && !isFetching) && children !== undefined && /*#__PURE__*/React.createElement(Animated.View, {
    entering: FadeIn,
    style: containerStyle
  }, children));
};

export { Frame as default };
//# sourceMappingURL=index.js.map
