/// <reference types="react" />
import React from 'react';
import { FC } from "react";
import { PressableProps, View, GestureResponderEvent } from 'react-native';
interface IPressHandler extends Omit<PressableProps, 'onPress'>, React.RefAttributes<View> {
    onPress?: ((event: GestureResponderEvent) => Promise<void>) | PressableProps['onPress'];
}
/**
 * Render press handler component cover
 * @constructor
 */
declare const PressHandler: FC<IPressHandler>;
export { PressHandler as default };
