import { objectWithoutProperties as _objectWithoutProperties, extends as _extends } from '../../_virtual/_rollupPluginBabelHelpers.js';
import React, { useCallback } from 'react';
import { Pressable } from 'react-native';
import ReactNativeHapticFeedback from 'react-native-haptic-feedback';
import Config from '../../services/config.js';

var _excluded = ["onPress", "disabled", "children"];
/**
 * Render press handler component cover
 * @constructor
 */
var PressHandler = function PressHandler(_ref) {
  var onPress = _ref.onPress,
    disabled = _ref.disabled,
    children = _ref.children,
    newProps = _objectWithoutProperties(_ref, _excluded);
  /**
   * Handle button pressed
   */
  var handleOnPress = useCallback(function (event) {
    ReactNativeHapticFeedback.trigger('impactMedium', Config.get('hapticFeedbackOptions'));
    void (onPress === null || onPress === void 0 ? void 0 : onPress(event));
  }, [onPress]);
  return /*#__PURE__*/React.createElement(Pressable, _extends({
    disabled: disabled,
    onPress: handleOnPress
  }, newProps), children);
};

export { PressHandler as default };
//# sourceMappingURL=index.js.map
