import { FC } from 'react';
import { ActivityIndicatorProps, ImageProps, ImageSourcePropType } from 'react-native';
import { FastImageProps, Source } from 'react-native-fast-image';
import { CircleProps, SvgProps } from 'react-native-svg';
interface IProgressiveImage {
    source: ImageSourcePropType | string;
    style?: ImageProps['style'];
    thumbnailSource?: ImageSourcePropType | string;
    loaderProps?: ActivityIndicatorProps;
    thumbnailProps?: Omit<ImageProps, 'source'>;
    sourceProps?: Omit<ImageProps, 'source'>;
    progressProps?: SvgProps;
    progressCircleProps?: CircleProps;
    fastProps?: FastImageProps;
    priority?: Source['priority'];
    isFastImg?: boolean;
    hasIndicator?: boolean;
    hasProgress?: boolean;
}
/**
 * Render progressive image
 * @constructor
 */
declare const ProgressiveImage: FC<IProgressiveImage>;
export { ProgressiveImage as default };
