import { ReplaceReturnType } from '@lomray/client-helpers/interfaces';
import { ComponentType, ReactElement, Ref } from 'react';
import { ImageSourcePropType, SectionListProps } from 'react-native';
import Animated from 'react-native-reanimated';
interface ISectionList<TEntity = Record<string, any>> extends SectionListProps<TEntity> {
    emptyListTitle?: string;
    emptyListText?: string;
    emptyListImg?: ImageSourcePropType;
    totalEntities?: number;
    isFetching?: boolean;
    isFirstRender?: boolean;
    placeholderCount?: number;
    placeholderContainerStyle?: Animated.AnimateProps<any>['style'];
    EmptyComponent?: ReactElement | false;
    PlaceholderComponent?: ReactElement | ComponentType;
    onRefresh?: ReplaceReturnType<NonNullable<SectionListProps<TEntity>['onRefresh']>, Promise<any>> | SectionListProps<TEntity>['onRefresh'];
    onEndReachedAsync?: () => Promise<any>;
}
declare const _default: <TE, TR>(p: ISectionList<TE> & {
    ref?: Ref<TR> | undefined;
}) => ReactElement;
export { _default as default, ISectionList };
