import React from 'react';
import { View } from 'react-native';
import { WebView as WebView$1 } from 'react-native-webview';
import ActivityIndicator from '../activity-indicator/index.js';
import styles from './styles.js';

/**
 * Custom webview component with loading.
 */
var WebView = function WebView(_ref) {
  var uri = _ref.uri;
  return /*#__PURE__*/React.createElement(View, {
    style: styles.container
  }, /*#__PURE__*/React.createElement(WebView$1, {
    startInLoadingState: true,
    renderLoading: function renderLoading() {
      return /*#__PURE__*/React.createElement(View, {
        style: styles.wrapperLoader
      }, /*#__PURE__*/React.createElement(ActivityIndicator, {
        isFetching: true,
        size: "large"
      }));
    },
    source: {
      uri: uri
    },
    style: styles.container
  }));
};

export { WebView as default };
//# sourceMappingURL=index.js.map
