import { asyncToGenerator as _asyncToGenerator, regeneratorRuntime as _regeneratorRuntime } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { appleAuth } from '@invertase/react-native-apple-authentication';
import auth from '@react-native-firebase/auth';

/**
 * Sign in through Apple
 */
var AppleSignIn = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
    var _auth$currentUser;
    var scopes,
      appleAuthRequestResponse,
      identityToken,
      nonce,
      fullName,
      appleCredential,
      _ref2,
      givenName,
      familyName,
      middleName,
      nickname,
      _args = arguments;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          scopes = _args.length > 0 && _args[0] !== undefined ? _args[0] : [appleAuth.Scope.EMAIL, appleAuth.Scope.FULL_NAME];
          _context.next = 3;
          return appleAuth.performRequest({
            requestedOperation: appleAuth.Operation.LOGIN,
            requestedScopes: scopes
          });
        case 3:
          appleAuthRequestResponse = _context.sent;
          if (appleAuthRequestResponse.identityToken) {
            _context.next = 6;
            break;
          }
          throw new Error('Apple Sign-In failed - no identify token returned');
        case 6:
          // Create a Firebase credential from the response
          identityToken = appleAuthRequestResponse.identityToken, nonce = appleAuthRequestResponse.nonce, fullName = appleAuthRequestResponse.fullName;
          appleCredential = auth.AppleAuthProvider.credential(identityToken, nonce);
          _ref2 = fullName || {}, givenName = _ref2.givenName, familyName = _ref2.familyName, middleName = _ref2.middleName, nickname = _ref2.nickname; // Sign the user in with the credential
          _context.next = 11;
          return auth().signInWithCredential(appleCredential);
        case 11:
          _context.next = 13;
          return (_auth$currentUser = auth().currentUser) === null || _auth$currentUser === void 0 ? void 0 : _auth$currentUser.updateProfile({
            displayName: [givenName, familyName, middleName].filter(Boolean).join(' ') || nickname || 'Unknown'
          });
        case 13:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function AppleSignIn() {
    return _ref.apply(this, arguments);
  };
}();

export { AppleSignIn as default };
//# sourceMappingURL=apple-sign-in.js.map
