import { asyncToGenerator as _asyncToGenerator, regeneratorRuntime as _regeneratorRuntime } from '../../_virtual/_rollupPluginBabelHelpers.js';
import auth from '@react-native-firebase/auth';
import { AccessToken, LoginManager } from 'react-native-fbsdk-next';

/**
 * Sign in through Facebook
 */
var FacebookSignIn = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
    var permissions,
      result,
      error,
      data,
      facebookCredential,
      _args = arguments;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          permissions = _args.length > 0 && _args[0] !== undefined ? _args[0] : ['public_profile', 'email'];
          _context.next = 3;
          return LoginManager.logInWithPermissions(permissions);
        case 3:
          result = _context.sent;
          if (!result.isCancelled) {
            _context.next = 8;
            break;
          }
          error = new Error('User cancelled the login process'); // @ts-ignore set this for prevent show error
          error.code = '-5';
          throw error;
        case 8:
          _context.next = 10;
          return AccessToken.getCurrentAccessToken();
        case 10:
          data = _context.sent;
          if (data) {
            _context.next = 13;
            break;
          }
          throw new Error('Something went wrong obtaining access token');
        case 13:
          // Create a Firebase credential with the AccessToken
          facebookCredential = auth.FacebookAuthProvider.credential(data.accessToken); // Sign-in the user with the credential
          return _context.abrupt("return", auth().signInWithCredential(facebookCredential));
        case 15:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function FacebookSignIn() {
    return _ref.apply(this, arguments);
  };
}();

export { FacebookSignIn as default };
//# sourceMappingURL=facebook-sign-in.js.map
