import { objectSpread2 as _objectSpread2, asyncToGenerator as _asyncToGenerator, regeneratorRuntime as _regeneratorRuntime } from '../../_virtual/_rollupPluginBabelHelpers.js';
import auth from '@react-native-firebase/auth';
import { GoogleSignin } from '@react-native-google-signin/google-signin';
import Config from '../../services/config.js';

var initGoogleProvider = function initGoogleProvider(config) {
  return GoogleSignin.configure(_objectSpread2(_objectSpread2({
    offlineAccess: true
  }, Config.get('googleSignInConfig', {})), config));
};
/**
 * Sign in through Google
 */
var GoogleSignIn = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
    var _ref2,
      config,
      _yield$GoogleSignin$s,
      idToken,
      googleCredential,
      _args = arguments;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          _ref2 = _args.length > 0 && _args[0] !== undefined ? _args[0] : {}, config = _ref2.config;
          initGoogleProvider(config);
          // Get the users ID token
          _context.next = 4;
          return GoogleSignin.signIn();
        case 4:
          _yield$GoogleSignin$s = _context.sent;
          idToken = _yield$GoogleSignin$s.idToken;
          // Create a Google credential with the token
          googleCredential = auth.GoogleAuthProvider.credential(idToken); // Sign-in the user with the credential
          return _context.abrupt("return", auth().signInWithCredential(googleCredential));
        case 8:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function GoogleSignIn() {
    return _ref.apply(this, arguments);
  };
}();
/**
 * Sign out from Google
 * @constructor
 */
var GoogleSignOut = function GoogleSignOut() {
  var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    config = _ref3.config;
  initGoogleProvider(config);
  try {
    var _auth$currentUser;
    // For android need special logout
    var isGoogleProvider = (_auth$currentUser = auth().currentUser) === null || _auth$currentUser === void 0 ? void 0 : _auth$currentUser.providerData.some(function (_ref4) {
      var providerId = _ref4.providerId;
      return providerId === 'google.com';
    });
    if (isGoogleProvider) {
      return GoogleSignin.signOut();
    }
  } catch (e) {
    var _Config$get;
    (_Config$get = Config.get('logger')) === null || _Config$get === void 0 || _Config$get.error('Failed to sign out from Google:', e);
  }
  return undefined;
};

export { GoogleSignIn, GoogleSignOut };
//# sourceMappingURL=google-sign-in.js.map
