import { slicedToArray as _slicedToArray } from '../_virtual/_rollupPluginBabelHelpers.js';
import { useState, useEffect } from 'react';
import { Animated } from 'react-native';

/**
 * Animation create helper
 */
var useAnimation = function useAnimation(_ref) {
  var doAnimation = _ref.doAnimation,
    _ref$duration = _ref.duration,
    duration = _ref$duration === void 0 ? 300 : _ref$duration,
    _ref$useNativeDriver = _ref.useNativeDriver,
    useNativeDriver = _ref$useNativeDriver === void 0 ? true : _ref$useNativeDriver,
    _ref$toValue = _ref.toValue,
    toValue = _ref$toValue === void 0 ? 1 : _ref$toValue;
  var _useState = useState(new Animated.Value(0)),
    _useState2 = _slicedToArray(_useState, 1),
    animation = _useState2[0];
  useEffect(function () {
    Animated.timing(animation, {
      toValue: doAnimation ? toValue : 0,
      duration: duration,
      useNativeDriver: useNativeDriver
    }).start();
  }, [doAnimation, toValue]);
  return animation;
};

export { useAnimation as default };
//# sourceMappingURL=use-animation.js.map
