import { slicedToArray as _slicedToArray } from '../_virtual/_rollupPluginBabelHelpers.js';
import { useState, useEffect } from 'react';
import { Keyboard } from 'react-native';

var useKeyboardHeight = function useKeyboardHeight() {
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    keyboardHeight = _useState2[0],
    setKeyboardHeight = _useState2[1];
  var onKeyboardDidShow = function onKeyboardDidShow(e) {
    return setKeyboardHeight(e.endCoordinates.height);
  };
  var onKeyboardDidHide = function onKeyboardDidHide() {
    return setKeyboardHeight(0);
  };
  useEffect(function () {
    var showSubscription = Keyboard.addListener('keyboardDidShow', onKeyboardDidShow);
    var hideSubscription = Keyboard.addListener('keyboardDidHide', onKeyboardDidHide);
    return function () {
      showSubscription.remove();
      hideSubscription.remove();
    };
  }, []);
  return keyboardHeight;
};

export { useKeyboardHeight as default };
//# sourceMappingURL=use-keyboard-height.js.map
