import { objectWithoutProperties as _objectWithoutProperties } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { useRef, useEffect } from 'react';
import { Navigation } from 'react-native-navigation';
import { openHalfBottom, OVERLAY_ID } from './control.js';

var _excluded = ["isVisible", "deps"];
/**
 * Modal bottom half
 * @constructor
 */
var BottomHalf = function BottomHalf(_ref) {
  var isVisible = _ref.isVisible,
    deps = _ref.deps,
    props = _objectWithoutProperties(_ref, _excluded);
  var isOpened = useRef(false);
  var _props$id = props.id,
    id = _props$id === void 0 ? OVERLAY_ID : _props$id;
  useEffect(function () {
    if (isVisible && !isOpened.current) {
      // Open modal
      isOpened.current = true;
      void openHalfBottom(props);
      return;
    }
    if (!isVisible && isOpened.current) {
      // Close modal
      isOpened.current = false;
      Navigation.updateProps(id, {
        shouldClose: true
      });
    }
  }, [isVisible]);
  /**
   * Re-render components inside modal when deps changed
   */
  useEffect(function () {
    if (!isVisible) {
      return;
    }
    Navigation.updateProps(id, props);
  }, [isVisible, deps]);
  return null;
};

export { BottomHalf as default };
//# sourceMappingURL=index.js.map
