import { FCC } from '@lomray/client-helpers/interfaces';
import { ReactNode } from 'react';
import { StyleProp, ViewStyle, TextStyle, TextProps } from 'react-native';
interface ISlideModal {
    title: string;
    textDone?: string;
    textProps?: TextProps;
    titleProps?: TextProps;
    titleWrapperStyle?: StyleProp<ViewStyle>;
    titleStyle?: StyleProp<TextStyle>;
    doneStyle?: StyleProp<TextStyle>;
    onClose: () => Promise<void> | void;
    children: ReactNode;
}
/**
 * Custom slide modal component.
 * Show this modal via Navigation.showModal.
 */
declare const SlideModal: FCC<ISlideModal>;
export { SlideModal as default };
