import { extends as _extends } from '../../_virtual/_rollupPluginBabelHelpers.js';
import React from 'react';
import { View, Text, TouchableOpacity } from 'react-native';
import styles from './styles.js';

/**
 * Custom slide modal component.
 * Show this modal via Navigation.showModal.
 */
var SlideModal = function SlideModal(_ref) {
  var title = _ref.title,
    children = _ref.children,
    titleWrapperStyle = _ref.titleWrapperStyle,
    titleStyle = _ref.titleStyle,
    textProps = _ref.textProps,
    titleProps = _ref.titleProps,
    doneStyle = _ref.doneStyle,
    onClose = _ref.onClose,
    _ref$textDone = _ref.textDone,
    textDone = _ref$textDone === void 0 ? 'Done' : _ref$textDone;
  return /*#__PURE__*/React.createElement(View, {
    style: styles.container
  }, /*#__PURE__*/React.createElement(View, {
    style: [styles.titleWrapper, titleWrapperStyle]
  }, /*#__PURE__*/React.createElement(Text, _extends({
    style: [styles.title, titleStyle],
    allowFontScaling: false
  }, titleProps), title), /*#__PURE__*/React.createElement(TouchableOpacity, {
    onPress: function onPress() {
      return void onClose();
    },
    style: styles.doneWrapper
  }, /*#__PURE__*/React.createElement(Text, _extends({
    style: [styles.done, doneStyle],
    allowFontScaling: false
  }, textProps), textDone))), children);
};

export { SlideModal as default };
//# sourceMappingURL=index.js.map
