import SplashScreen from 'react-native-mixed-splash';
import { Navigation } from 'react-native-navigation';
import Config from '../../services/config.js';

var CloseSplashScreen = function CloseSplashScreen(hiddenOverlays) {
  var isLocalDevelopment = Config.get('isLocalDevelopment');
  // When reload bundle, this will work (with did appear listener not working)
  if (isLocalDevelopment) {
    SplashScreen.hide({
      fade: true
    });
    return;
  }
  // Only for production
  var sub = Navigation.events().registerComponentDidAppearListener(function (props) {
    // Skip overlay registration
    if (hiddenOverlays.includes(props.componentName)) {
      return;
    }
    SplashScreen.hide({
      fade: true
    });
    sub.remove();
  });
};

export { CloseSplashScreen as default };
//# sourceMappingURL=close-splash-screen.js.map
