import NetInfo from '@react-native-community/netinfo';
import { showTopFlashMessage } from '../../components/top-flash-messages/index.js';
import Config from '../../services/config.js';
import customI18n from '../../services/localization.js';

/**
 * Listening changing internet connection state
 */
var HandleChangeInternetConnection = function HandleChangeInternetConnection() {
  NetInfo.addEventListener(function (state) {
    if (!state.isConnected) {
      var _Config$get;
      (_Config$get = Config.get('logger')) === null || _Config$get === void 0 || _Config$get.info('No internet connection');
      showTopFlashMessage({
        message: customI18n.t('translation:noConnection'),
        description: customI18n.t('translation:checkConnection')
      });
    }
  });
};

export { HandleChangeInternetConnection as default };
//# sourceMappingURL=handle-change-internet-connection.js.map
