import { Navigation } from 'react-native-navigation';
import Config from '../../services/config.js';

var EventScreen;
(function (EventScreen) {
  EventScreen["overlay"] = "overlay";
  EventScreen["modal"] = "modal";
  EventScreen["screen"] = "screen";
})(EventScreen || (EventScreen = {}));
/**
 * Handle screen change
 */
var HandleChangeScreen = function HandleChangeScreen(_ref) {
  var hiddenOverlays = _ref.hiddenOverlays,
    hiddenModals = _ref.hiddenModals,
    callback = _ref.callback;
  var logger = Config.get('logger');
  Navigation.events().registerComponentDidAppearListener(function (params) {
    var componentId = params.componentId,
      componentName = params.componentName,
      componentType = params.componentType;
    if (componentType !== 'Component') {
      return;
    }
    if (hiddenOverlays.includes(componentName)) {
      // Overlay open
      logger === null || logger === void 0 || logger.info("View overlay: ".concat(componentName, ". Id: ").concat(componentId));
      callback === null || callback === void 0 || callback(EventScreen.overlay, params);
      return;
    }
    if (hiddenModals.includes(componentName)) {
      // Modal change
      logger === null || logger === void 0 || logger.info("View modal: ".concat(componentName, ". Id: ").concat(componentId));
      callback === null || callback === void 0 || callback(EventScreen.modal, params);
      return;
    }
    // Screen change (push)
    logger === null || logger === void 0 || logger.info("View screen: ".concat(componentName, ". Id: ").concat(componentId));
    callback === null || callback === void 0 || callback(EventScreen.screen, params);
  });
};

export { EventScreen, HandleChangeScreen };
//# sourceMappingURL=handle-change-screen.js.map
