import ReactNativeHapticFeedback from 'react-native-haptic-feedback';
import { Navigation } from 'react-native-navigation';
import Config from '../../services/config.js';

/**
 * Listening changing bottom tab navigator selection
 * BottomTabEventListener to reset screenshots when switching tabs
 */
var HandleClickBottomBar = function HandleClickBottomBar(callback) {
  var unsubscribe = Navigation.events().registerBottomTabSelectedListener(function () {
    ReactNativeHapticFeedback.trigger('impactMedium', Config.get('hapticFeedbackOptions'));
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    callback === null || callback === void 0 || callback.apply(void 0, args);
  });
  return function () {
    return unsubscribe.remove();
  };
};

export { HandleClickBottomBar as default };
//# sourceMappingURL=handle-click-bottom-bar.js.map
