import { toConsumableArray as _toConsumableArray } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { Navigation } from 'react-native-navigation';

/**
 * Register application screens
 * @constructor
 */
var RegisterScreens = function RegisterScreens(screens, wrapper) {
  screens.forEach(function (Component, componentName) {
    if (Array.isArray(Component)) {
      return Navigation.registerComponent(componentName, function () {
        return wrapper.apply(void 0, _toConsumableArray(Component));
      });
    }
    return Navigation.registerComponent(componentName, function () {
      return wrapper(Component);
    }, function () {
      return Component;
    });
  });
};

export { RegisterScreens as default };
//# sourceMappingURL=register-screens.js.map
