import { asyncToGenerator as _asyncToGenerator, regeneratorRuntime as _regeneratorRuntime } from '../../_virtual/_rollupPluginBabelHelpers.js';
import messaging from '@react-native-firebase/messaging';
import Config from '../../services/config.js';

/**
 * Request IOS Push Notification permissions
 */
var RequestPushNotificationPermission = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
    var logger, authStatus, isEnabled;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          logger = Config.get('logger');
          _context.prev = 1;
          _context.next = 4;
          return messaging().requestPermission();
        case 4:
          authStatus = _context.sent;
          isEnabled = authStatus === messaging.AuthorizationStatus.AUTHORIZED || authStatus === messaging.AuthorizationStatus.PROVISIONAL || authStatus === messaging.AuthorizationStatus.EPHEMERAL;
          logger === null || logger === void 0 || logger.info("Push permissions authorization status: ".concat(authStatus, " (").concat(String(isEnabled), ")"));
          return _context.abrupt("return", isEnabled);
        case 10:
          _context.prev = 10;
          _context.t0 = _context["catch"](1);
          logger === null || logger === void 0 || logger.error('Request push permissions failed:', _context.t0);
          return _context.abrupt("return", false);
        case 14:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[1, 10]]);
  }));
  return function RequestPushNotificationPermission() {
    return _ref.apply(this, arguments);
  };
}();

export { RequestPushNotificationPermission as default };
//# sourceMappingURL=request-push-notification-permissions.js.map
