import { objectSpread2 as _objectSpread2 } from '../_virtual/_rollupPluginBabelHelpers.js';
import { wp, isAndroid } from '@lomray/react-native-layout-helper';

var SCREEN_ANIMATION_DURATION = 300;
var baseAnimation = {
  duration: SCREEN_ANIMATION_DURATION,
  interpolation: {
    type: 'fastOutSlowIn'
  }
};
var slideInFromRight = {
  translationX: _objectSpread2({
    from: wp(100),
    to: 0
  }, baseAnimation)
};
var slideInFromLeft = {
  translationX: _objectSpread2({
    from: -50,
    to: 0
  }, baseAnimation)
};
var slideOutToLeft = {
  translationX: _objectSpread2({
    from: 0,
    to: -50
  }, baseAnimation)
};
var slideOutToRight = {
  translationX: _objectSpread2({
    from: 0,
    to: wp(100)
  }, baseAnimation)
};
var slideOutAndExit = {
  scaleX: _objectSpread2({
    from: 1,
    to: 0.9
  }, baseAnimation),
  scaleY: _objectSpread2({
    from: 1,
    to: 0.9
  }, baseAnimation),
  alpha: _objectSpread2(_objectSpread2({}, baseAnimation), {}, {
    from: 1,
    to: 0,
    interpolation: {
      type: 'decelerate',
      factor: 0.8
    }
  }),
  translationY: _objectSpread2({
    from: 0,
    to: 100
  }, baseAnimation)
};
/**
 * Screen animations
 *
 * @type {object}
 */
var screenAnimations = _objectSpread2(_objectSpread2({}, isAndroid ? {
  push: {
    content: {
      enter: slideInFromRight,
      exit: slideOutToLeft
    }
  },
  pop: {
    content: {
      enter: slideInFromLeft,
      exit: slideOutToRight
    }
  },
  setStackRoot: {
    waitForRender: true,
    content: {
      enter: slideInFromRight,
      exit: slideOutAndExit
    }
  }
} : {}), {}, {
  setRoot: _objectSpread2({
    waitForRender: true
  }, isAndroid ? {
    enter: {
      waitForRender: true,
      alpha: {
        from: 0,
        to: 1,
        duration: 500,
        interpolation: {
          type: 'accelerate'
        }
      }
    },
    exit: {
      waitForRender: true,
      alpha: {
        from: 1,
        to: 0,
        duration: 1000,
        startDelay: 100,
        interpolation: {
          type: 'accelerate'
        }
      }
    }
  } : {
    alpha: {
      from: 0,
      to: 1,
      duration: 400,
      startDelay: 100,
      interpolation: {
        type: 'accelerate'
      }
    }
  })
});

export { screenAnimations as default };
//# sourceMappingURL=screen-animation.js.map
