import { defineProperty as _defineProperty, createClass as _createClass, classCallCheck as _classCallCheck, asyncToGenerator as _asyncToGenerator, objectWithoutProperties as _objectWithoutProperties, objectSpread2 as _objectSpread2, regeneratorRuntime as _regeneratorRuntime } from '../_virtual/_rollupPluginBabelHelpers.js';
import { isIOS } from '@lomray/react-native-layout-helper';
import analytics from '@react-native-firebase/analytics';
import _ from 'lodash';
import DeviceInfo from 'react-native-device-info';
import { requestTrackingPermission, getTrackingStatus } from 'react-native-tracking-transparency';
import Config from './config.js';

var _excluded = ["id"],
  _excluded2 = ["hasRegisterDeepLinkListeners"];
var APP_EVENT;
(function (APP_EVENT) {
  APP_EVENT["APP_START"] = "app_start";
  APP_EVENT["VIEW_SCREEN"] = "view_screen";
  APP_EVENT["VIEW_OVERLAY"] = "view_overlay";
  APP_EVENT["VIEW_MODAL"] = "view_modal";
  APP_EVENT["CHANGE_APP_STATE"] = "change_app_state";
  APP_EVENT["CHANGE_STACK_ROOT"] = "change_stack_root";
  APP_EVENT["USER_SIGN_IN"] = "user_sign_in";
  APP_EVENT["USER_SIGN_UP"] = "user_sign_up";
  APP_EVENT["PURCHASE"] = "purchase";
  APP_EVENT["PURCHASE_TRIAL"] = "purchase_trial";
  APP_EVENT["AD_SHOW"] = "custom_ad_show";
  APP_EVENT["AD_CLICK"] = "custom_ad_click";
  APP_EVENT["PUSH_NOTIFICATION_OPEN"] = "push_notification_open";
  APP_EVENT["PUSH_NOTIFICATION_INITIAL"] = "push_notification_initial";
  APP_EVENT["DEEP_LINK_OPEN"] = "deep_link_opened";
  APP_EVENT["DEEP_LINK_INITIAL"] = "deep_link_initial";
})(APP_EVENT || (APP_EVENT = {}));
/**
 * Application analytics
 */
var Analytics = /*#__PURE__*/function () {
  /**
   * @constructor
   * @private
   */
  function Analytics(_ref) {
    var _this = this;
    var sdk = _ref.sdk,
      amplitudeToken = _ref.amplitudeToken,
      appsFlyerToken = _ref.appsFlyerToken,
      appsFlyerId = _ref.appsFlyerId,
      isEnableCollection = _ref.isEnableCollection,
      isATT = _ref.isATT,
      onATT = _ref.onATT,
      onTrackUser = _ref.onTrackUser,
      onTrackEvent = _ref.onTrackEvent;
    _classCallCheck(this, Analytics);
    /**
     * Analytics available SDK's
     */
    _defineProperty(this, "sdk", void 0);
    /**
     * Disable analytics
     * @protected
     */
    _defineProperty(this, "isDisabled", void 0);
    /**
     * Production env
     */
    _defineProperty(this, "isProd", false);
    /**
     * Amplitude token
     */
    _defineProperty(this, "amplitudeToken", void 0);
    /**
     * AppsFlyer token
     */
    _defineProperty(this, "appsFlyerToken", void 0);
    /**
     * AppsFlyer app id
     */
    _defineProperty(this, "appsFlyerId", void 0);
    /**
     * Registered deep ling listeners
     */
    _defineProperty(this, "unsubscribeDeepLinkListeners", void 0);
    /**
     * @private
     */
    _defineProperty(this, "logger", void 0);
    /**
     * Enable check app tracking transparency
     */
    _defineProperty(this, "isATT", true);
    /**
     * Enable automatically analytic collection
     */
    _defineProperty(this, "isEnableCollection", true);
    /**
     * ATT status
     * @protected
     */
    _defineProperty(this, "hasAllowATT", null);
    /**
     * Trigger when ATT resolves
     * @protected
     */
    _defineProperty(this, "onATT", void 0);
    /**
     * Extra user set callback
     * @protected
     */
    _defineProperty(this, "onTrackUser", void 0);
    /**
     * Extra event callback
     * @protected
     */
    _defineProperty(this, "onTrackEvent", void 0);
    /**
     * Initial check ATT
     * Enable analytic collection only for production
     */
    _defineProperty(this, "initialATT", /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      var _this$logger;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return _this.checkATT().then(function (result) {
              var _this$onATT, _this$sdk$facebook, _this$sdk$amplitude;
              (_this$onATT = _this.onATT) === null || _this$onATT === void 0 || _this$onATT.call(_this, result);
              if (!result) {
                return;
              }
              void ((_this$sdk$facebook = _this.sdk.facebook) === null || _this$sdk$facebook === void 0 ? void 0 : _this$sdk$facebook.Settings.setAdvertiserTrackingEnabled(true));
              void analytics().setAnalyticsCollectionEnabled(_this.isProd);
              void ((_this$sdk$amplitude = _this.sdk.amplitude) === null || _this$sdk$amplitude === void 0 ? void 0 : _this$sdk$amplitude.Amplitude.getInstance().setDeviceId(DeviceInfo.getUniqueIdSync()));
            });
          case 3:
            _context.next = 8;
            break;
          case 5:
            _context.prev = 5;
            _context.t0 = _context["catch"](0);
            (_this$logger = _this.logger) === null || _this$logger === void 0 || _this$logger.info('Request app tracking transparency failed.', _context.t0);
          case 8:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[0, 5]]);
    })));
    this.isDisabled = !Config.get('isProdDeployment');
    this.isProd = Config.get('isProd', false);
    this.logger = Config.get('logger');
    this.sdk = sdk;
    this.amplitudeToken = amplitudeToken;
    this.appsFlyerToken = appsFlyerToken;
    this.appsFlyerId = appsFlyerId;
    this.isATT = isATT !== null && isATT !== void 0 ? isATT : true;
    this.isEnableCollection = isEnableCollection !== null && isEnableCollection !== void 0 ? isEnableCollection : true;
    this.onATT = onATT;
    this.onTrackUser = onTrackUser;
    this.onTrackEvent = onTrackEvent;
  }
  /**
   * Init analytics
   */
  _createClass(Analytics, [{
    key: "registerDeepLinkListeners",
    value:
    /**
     * Add deep link listeners
     */
    function registerDeepLinkListeners() {
      var _this$sdk$appsflyer;
      var unsubscribe = (_this$sdk$appsflyer = this.sdk.appsflyer) === null || _this$sdk$appsflyer === void 0 ? void 0 : _this$sdk$appsflyer.onInstallConversionData(function (res) {
        Analytics.deepLinkData = res.data;
      });
      return function () {
        unsubscribe === null || unsubscribe === void 0 || unsubscribe();
      };
    }
    /**
     * Get ATT status
     */
  }, {
    key: "getATTStatus",
    value: function getATTStatus() {
      return this.hasAllowATT;
    }
    /**
     * Initialize analytics, show permission modals
     * @protected
     */
  }, {
    key: "initialize",
    value: (function () {
      var _initialize = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
        var _this$sdk$facebook2,
          _this$sdk$amplitude2,
          _this2 = this;
        var result, Amplitude;
        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              if (!this.isDisabled) {
                _context2.next = 2;
                break;
              }
              return _context2.abrupt("return", Promise.resolve(false));
            case 2:
              if (!this.isEnableCollection) {
                _context2.next = 5;
                break;
              }
              _context2.next = 5;
              return analytics().setAnalyticsCollectionEnabled(true);
            case 5:
              (_this$sdk$facebook2 = this.sdk.facebook) === null || _this$sdk$facebook2 === void 0 || _this$sdk$facebook2.Settings.initializeSDK();
              result = [];
              Amplitude = (_this$sdk$amplitude2 = this.sdk.amplitude) === null || _this$sdk$amplitude2 === void 0 ? void 0 : _this$sdk$amplitude2.Amplitude.getInstance();
              if (Amplitude && this.amplitudeToken) {
                result.push(Amplitude.init(this.amplitudeToken).then(function (value) {
                  var _this2$logger;
                  (_this2$logger = _this2.logger) === null || _this2$logger === void 0 || _this2$logger.info('Amplitude success initialize: ', value);
                  return value;
                })["catch"](function (e) {
                  var _this2$logger2;
                  (_this2$logger2 = _this2.logger) === null || _this2$logger2 === void 0 || _this2$logger2.warn('Amplitude failed initialize: ', e);
                  return false;
                }));
              }
              if (this.appsFlyerId && this.appsFlyerToken && this.sdk.appsflyer) {
                result.push(new Promise(function (resolve) {
                  _this2.sdk.appsflyer.initSdk({
                    devKey: _this2.appsFlyerToken,
                    isDebug: !_this2.isProd,
                    appId: _this2.appsFlyerId,
                    manualStart: true,
                    onInstallConversionDataListener: true,
                    onDeepLinkListener: false,
                    timeToWaitForATTUserAuthorization: 10
                  }, function (res) {
                    var _this2$logger3;
                    (_this2$logger3 = _this2.logger) === null || _this2$logger3 === void 0 || _this2$logger3.info('AppsFlyer success initialize: ', res);
                    resolve(res);
                  }, function (error) {
                    var _this2$logger4;
                    (_this2$logger4 = _this2.logger) === null || _this2$logger4 === void 0 || _this2$logger4.warn('AppsFlyer failed initialize: ', error);
                    resolve(false);
                  });
                }));
              }
              return _context2.abrupt("return", Promise.all(result));
            case 11:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function initialize() {
        return _initialize.apply(this, arguments);
      }
      return initialize;
    }())
  }, {
    key: "checkATT",
    value: (
    /**
     * Check APP TRACKING TRANSPARENCY
     */
    function () {
      var _checkATT = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
        var _this$logger3;
        var status, _this$logger2;
        return _regeneratorRuntime().wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              if (!(!isIOS || !this.isATT)) {
                _context3.next = 2;
                break;
              }
              return _context3.abrupt("return", true);
            case 2:
              _context3.next = 4;
              return getTrackingStatus();
            case 4:
              status = _context3.sent;
              if (!(status === 'not-determined')) {
                _context3.next = 10;
                break;
              }
              (_this$logger2 = this.logger) === null || _this$logger2 === void 0 || _this$logger2.info('Request app tracking transparency...');
              _context3.next = 9;
              return requestTrackingPermission();
            case 9:
              status = _context3.sent;
            case 10:
              this.hasAllowATT = status === 'unavailable' || status === 'authorized';
              (_this$logger3 = this.logger) === null || _this$logger3 === void 0 || _this$logger3.info('App tracking transparency status: ', status);
              return _context3.abrupt("return", this.hasAllowATT);
            case 13:
            case "end":
              return _context3.stop();
          }
        }, _callee3, this);
      }));
      function checkATT() {
        return _checkATT.apply(this, arguments);
      }
      return checkATT;
    }()
    /**
     * Set user
     */
    )
  }, {
    key: "setUser",
    value: function setUser(user) {
      var _this$sdk$amplitude3,
        _this3 = this;
      if (this.isDisabled || !this.isATT) {
        return;
      }
      if (!user) {
        return;
      }
      var Amplitude = (_this$sdk$amplitude3 = this.sdk.amplitude) === null || _this$sdk$amplitude3 === void 0 ? void 0 : _this$sdk$amplitude3.Amplitude.getInstance();
      void this.checkATT().then(function (result) {
        var _this3$onTrackUser, _this3$sdk$facebook, _this3$sdk$facebook3, _this3$sdk$appsflyer;
        if (!result || !user) {
          return;
        }
        var id = user.id,
          properties = _objectWithoutProperties(user, _excluded);
        var userId = String(id);
        var identify = _this3.sdk.amplitude ? new _this3.sdk.amplitude.Identify() : undefined;
        var shouldSkip = (_this3$onTrackUser = _this3.onTrackUser) === null || _this3$onTrackUser === void 0 ? void 0 : _this3$onTrackUser.call(_this3, user, {
          amplitude: identify,
          google: analytics(),
          fb: (_this3$sdk$facebook = _this3.sdk.facebook) === null || _this3$sdk$facebook === void 0 ? void 0 : _this3$sdk$facebook.AppEventsLogger,
          appsFlyer: _this3.sdk.appsflyer
        });
        if (!shouldSkip) {
          var _this3$sdk$facebook2;
          void analytics().setUserProperties(properties);
          void (Amplitude === null || Amplitude === void 0 ? void 0 : Amplitude.setUserProperties(properties));
          (_this3$sdk$facebook2 = _this3.sdk.facebook) === null || _this3$sdk$facebook2 === void 0 || _this3$sdk$facebook2.AppEventsLogger.setUserData(_.pick(properties, ['email', 'firstName', 'lastName', 'phone', 'dateOfBirth', 'gender', 'city', 'state', 'zip', 'country']));
        }
        void (Amplitude === null || Amplitude === void 0 ? void 0 : Amplitude.setUserId(userId));
        void (Amplitude === null || Amplitude === void 0 ? void 0 : Amplitude.identify(identify));
        (_this3$sdk$facebook3 = _this3.sdk.facebook) === null || _this3$sdk$facebook3 === void 0 || _this3$sdk$facebook3.AppEventsLogger.setUserID(userId);
        (_this3$sdk$appsflyer = _this3.sdk.appsflyer) === null || _this3$sdk$appsflyer === void 0 || _this3$sdk$appsflyer.setCustomerUserId(userId);
      });
    }
    /**
     * Track event
     * @protected
     */
  }, {
    key: "setEvent",
    value: function setEvent(eventName) {
      var _this$sdk$amplitude4, _this$onTrackEvent, _this$onTrackEvent2, _this$sdk$facebook3, _this$sdk$facebook4, _this$sdk$appsflyer2, _this$sdk$appsflyer3, _this$sdk$facebook5, _this$sdk$appsflyer4;
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      if (this.isDisabled) {
        return;
      }
      var Amplitude = (_this$sdk$amplitude4 = this.sdk.amplitude) === null || _this$sdk$amplitude4 === void 0 ? void 0 : _this$sdk$amplitude4.Amplitude.getInstance();
      var shouldSkip = (_this$onTrackEvent = (_this$onTrackEvent2 = this.onTrackEvent) === null || _this$onTrackEvent2 === void 0 ? void 0 : _this$onTrackEvent2.call(this, eventName, props, {
        google: analytics(),
        amplitude: Amplitude,
        fb: (_this$sdk$facebook3 = this.sdk.facebook) === null || _this$sdk$facebook3 === void 0 ? void 0 : _this$sdk$facebook3.AppEventsLogger,
        appsFlyer: this.sdk.appsflyer
      })) !== null && _this$onTrackEvent !== void 0 ? _this$onTrackEvent : false;
      if (shouldSkip) {
        return;
      }
      switch (eventName) {
        case APP_EVENT.VIEW_MODAL:
        case APP_EVENT.VIEW_SCREEN:
        case APP_EVENT.VIEW_OVERLAY:
          // eslint-disable-next-line camelcase
          void analytics().logScreenView({
            screen_name: props === null || props === void 0 ? void 0 : props.name,
            screen_class: eventName
          });
          break;
        case APP_EVENT.CHANGE_APP_STATE:
          if (props.nextAppState === 'active') {
            void analytics().logAppOpen();
          }
          break;
        case APP_EVENT.USER_SIGN_UP:
          void analytics().logSignUp({
            method: props.method
          });
          break;
        case APP_EVENT.USER_SIGN_IN:
          void analytics().logLogin({
            method: props.method
          });
          break;
        case APP_EVENT.PURCHASE:
          var price = Number(Number(props.price || 0).toFixed(2));
          var currency = props.currency || 'USD';
          var count = Number(props.count || 1);
          var extraParams = props.params || {};
          void (Amplitude === null || Amplitude === void 0 ? void 0 : Amplitude.logRevenue({
            price: price,
            quantity: count,
            eventProperties: extraParams
          }));
          void analytics().logPurchase({
            value: price,
            currency: currency
          });
          (_this$sdk$facebook4 = this.sdk.facebook) === null || _this$sdk$facebook4 === void 0 || _this$sdk$facebook4.AppEventsLogger.logPurchase(price, currency, extraParams);
          void ((_this$sdk$appsflyer2 = this.sdk.appsflyer) === null || _this$sdk$appsflyer2 === void 0 ? void 0 : _this$sdk$appsflyer2.logEvent('af_subscribe', _objectSpread2({
            // eslint-disable-next-line camelcase
            af_revenue: price,
            // eslint-disable-next-line camelcase
            af_currency: currency
          }, extraParams)));
          break;
        case APP_EVENT.APP_START:
          Object.assign(props, Analytics.deepLinkData);
          (_this$sdk$appsflyer3 = this.sdk.appsflyer) === null || _this$sdk$appsflyer3 === void 0 || _this$sdk$appsflyer3.startSdk();
          break;
      }
      void (Amplitude === null || Amplitude === void 0 ? void 0 : Amplitude.logEvent(eventName, props));
      (_this$sdk$facebook5 = this.sdk.facebook) === null || _this$sdk$facebook5 === void 0 || _this$sdk$facebook5.AppEventsLogger.logEvent(eventName, props);
      void analytics().logEvent(eventName, props);
      void ((_this$sdk$appsflyer4 = this.sdk.appsflyer) === null || _this$sdk$appsflyer4 === void 0 ? void 0 : _this$sdk$appsflyer4.logEvent(eventName, props));
    }
    /**
     * Set user identity to analytics
     */
  }], [{
    key: "init",
    value: function init(_ref3) {
      var _ref3$hasRegisterDeep = _ref3.hasRegisterDeepLinkListeners,
        hasRegisterDeepLinkListeners = _ref3$hasRegisterDeep === void 0 ? false : _ref3$hasRegisterDeep,
        params = _objectWithoutProperties(_ref3, _excluded2);
      if (this.instance === null) {
        this.instance = new Analytics(params);
        if (hasRegisterDeepLinkListeners) {
          this.instance.unsubscribeDeepLinkListeners = this.instance.registerDeepLinkListeners();
        }
      }
      return this.instance.initialize();
    }
    /**
     * Get instance
     */
  }, {
    key: "get",
    value: function get() {
      if (!this.instance) {
        throw new Error('Call "init" before try to get analytic instance.');
      }
      return this.instance;
    }
  }, {
    key: "trackUser",
    value: function trackUser(user) {
      return Analytics.get().setUser(user);
    }
    /**
     * Track application event
     */
  }, {
    key: "trackEvent",
    value: function trackEvent(eventName) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return Analytics.get().setEvent(eventName, props);
    }
  }]);
  return Analytics;
}();
/**
 * @protected
 */
_defineProperty(Analytics, "instance", null);
/**
 * @protected
 */
_defineProperty(Analytics, "deepLinkData", null);

export { APP_EVENT, Analytics };
//# sourceMappingURL=analytics.js.map
