import { ConfigureParams } from '@react-native-google-signin/google-signin';
import { MessageOptions, MessageType } from 'react-native-flash-message';
import { HapticOptions } from 'react-native-haptic-feedback';
import { ILogType } from "./log.js";
interface IConfigParams {
    googleSignInConfig?: ConfigureParams & {
        webClientId: string;
    };
    logger?: ILogType;
    isLocalDevelopment?: boolean;
    isTests?: boolean;
    isProd?: boolean;
    isProdDeployment?: boolean;
    appKeyName?: string;
    appBranch?: string;
    packageName?: string;
    topFlashMessage?: Partial<Record<MessageType, Partial<MessageOptions>>> & {
        commonOptions?: Partial<MessageOptions>;
    };
    hapticFeedbackOptions?: HapticOptions;
    codepush?: {
        ios: string;
        android: string;
    };
    indicators?: {
        activity?: {
            color: string;
            backgroundColor?: string;
        };
        loader?: {
            color: string;
        };
    };
}
/**
 * Common class for share config between application and external packages
 * Call setup before start application
 */
declare class Config {
    /**
     * @private
     */
    private params;
    /**
     * @private
     */
    private isSetup;
    /**
     * Set config
     */
    /**
     * Set config
     */
    setup(params: IConfigParams): void;
    /**
     * Get config
     */
    /**
     * Get config
     */
    get<TKey extends keyof IConfigParams, TDefault = undefined>(key: TKey, defaultValue?: TDefault): IConfigParams[TKey] | TDefault;
}
declare const _default: Config;
export { _default as default, IConfigParams };
