import { createClass as _createClass, classCallCheck as _classCallCheck, defineProperty as _defineProperty } from '../_virtual/_rollupPluginBabelHelpers.js';
import _ from 'lodash';

/**
 * Common class for share config between application and external packages
 * Call setup before start application
 */
var Config = /*#__PURE__*/function () {
  function Config() {
    _classCallCheck(this, Config);
    /**
     * @private
     */
    _defineProperty(this, "params", {
      isLocalDevelopment: false,
      isTests: false,
      isProd: false,
      isProdDeployment: false,
      appKeyName: 'unknown',
      topFlashMessage: {
        danger: {
          backgroundColor: '#DB3737'
        },
        success: {
          backgroundColor: '#28a745'
        },
        info: {
          backgroundColor: '#222224'
        }
      },
      hapticFeedbackOptions: {
        enableVibrateFallback: false,
        ignoreAndroidSystemSettings: true
      },
      indicators: {
        activity: {
          color: '#FFFFFF'
        },
        loader: {
          color: '#FFFFFF'
        }
      }
    });
    /**
     * @private
     */
    _defineProperty(this, "isSetup", false);
  }
  _createClass(Config, [{
    key: "setup",
    value:
    /**
     * Set config
     */
    function setup(params) {
      var _this$params;
      this.params = _.merge((_this$params = this.params) !== null && _this$params !== void 0 ? _this$params : {}, params !== null && params !== void 0 ? params : {});
      this.isSetup = true;
    }
    /**
     * Get config
     */
  }, {
    key: "get",
    value: function get(key, defaultValue) {
      var _this$params$key, _this$params2;
      if (!this.isSetup) {
        console.warn("Don't try get config value before setup (Config.get).");
      }
      return (_this$params$key = (_this$params2 = this.params) === null || _this$params2 === void 0 ? void 0 : _this$params2[key]) !== null && _this$params$key !== void 0 ? _this$params$key : defaultValue;
    }
  }]);
  return Config;
}();
var Config$1 = new Config();

export { Config$1 as default };
//# sourceMappingURL=config.js.map
