import { objectSpread2 as _objectSpread2 } from '../_virtual/_rollupPluginBabelHelpers.js';
import i18n from 'i18next';
import { initReactI18next } from 'react-i18next';
import { getLocales, findBestLanguageTag } from 'react-native-localize';

var customI18n = i18n;
/**
 * Detects what language is installed as default on the device
 */
customI18n.getSystemLocale = function () {
  var localeArray = getLocales().map(function (item) {
    return item.languageCode;
  });
  var language = findBestLanguageTag(localeArray);
  if (!language) {
    return customI18n.defaultLanguage;
  }
  return language.languageTag;
};
var originalInit = i18n.init.bind(i18n);
var customInit = function customInit(options, callback) {
  customI18n.use(initReactI18next);
  return originalInit(_objectSpread2({
    compatibilityJSON: 'v3',
    load: 'languageOnly',
    fallbackLng: 'en',
    lng: customI18n.defaultLanguage,
    keySeparator: false,
    defaultNS: 'translation'
  }, options), callback);
};
customI18n.init = customInit.bind(i18n);

export { customI18n as default };
//# sourceMappingURL=localization.js.map
