import NewRelic from 'newrelic-react-native-agent';
import { configLoggerType, logger } from 'react-native-logs';
type TLogger = ReturnType<(typeof logger)['createLogger']>;
interface ILogType extends TLogger {
    payload: Record<string, any>;
    setPayload(key: string, value: string): void;
}
interface ILoggerOptions {
    params?: configLoggerType;
    crashlytics?: any;
    newrelic?: typeof NewRelic;
    grafana?: {
        url: string;
        token: string;
    };
    hasTempMemoryTransport?: boolean;
}
declare const initLogger: ({ grafana, crashlytics, newrelic, hasTempMemoryTransport, params, }?: ILoggerOptions) => ILogType;
export { initLogger as default, ILogType, ILoggerOptions };
