interface IVersionCheckOptions {
    bundleId: string;
    countryCode: string;
    iosStoreId?: string;
}
/**
 * Check app version from stores
 */
declare class VersionCheck {
    /**
     * @private
     */
    private readonly options;
    /**
     * @private
     */
    private logger?;
    /**
     * @constructor
     * @private
     */
    /**
     * @constructor
     * @private
     */
    private constructor();
    /**
     * Init service
     */
    /**
     * Init service
     */
    static init(options: IVersionCheckOptions): VersionCheck;
    /**
     * Get store app version
     */
    /**
     * Get store app version
     */
    private getStoreVersion;
    /**
     * Check if current version is old and need update
     */
    /**
     * Check if current version is old and need update
     */
    needUpdate(): Promise<{
        hasUpdate: boolean;
        storeUrl: string;
    }>;
    /**
     * Get store url
     */
    /**
     * Get store url
     */
    getStoreUrl(): string;
    /**
     *  Locale compare returns
     *  0: version strings are equal
     *  1: 1st is greater than 2nd
     * -1: 2nd is greater than 1st
     *
     * To convert to bool, we use returnedValue > 0
     */
    private compareSoftwareVersions;
}
export { VersionCheck as default };
