/**
 * Application version store
 */
declare class AppVersionStore {
    /**
     * This is singleton
     */
    static isGlobal: boolean;
    /**
     * Current application version
     */
    version: string;
    /**
     * Current application build number
     */
    build: string;
    /**
     * Codepush version
     *
     * c - codepush build
     * n - native build
     * e - error
     */
    codepushVersion: string;
    /**
     * Unsubscribe callback
     * @private
     */
    private unsubscribeAppCheck;
    /**
     * @private
     */
    private logger?;
    /**
     * @constructor
     */
    /**
     * @constructor
     */
    constructor();
    /**
     * Add codepush subscribers
     */
    addSubscribes: () => void;
    /**
     * Set codepush version
     */
    /**
     * Set codepush version
     */
    setCodepushVersion(version: string): void;
    /**
     * App version
     */
    get versionOutput(): string;
    /**
     * Check codepush releases and apply
     * @private
     */
    /**
     * Check codepush releases and apply
     * @private
     */
    private listenCodePush;
}
export { AppVersionStore as default };
