import { MatchKeyTypes } from '@lomray/client-helpers/interfaces';
type TParamsKeys<TS> = keyof TS;
type TParamsBool<TS> = MatchKeyTypes<TS, boolean>;
type TParamsInt<TS> = MatchKeyTypes<TS, number>;
/**
 * Storage for global application parameters
 */
declare class ConfigStore<TParams> {
    static isGlobal: boolean;
    /**
     * State
     */
    params: TParams;
    /**
     * @constructor
     */
    /**
     * @constructor
     */
    constructor();
    /**
     * Set value of key
     */
    /**
     * Set value of key
     */
    set<TKey extends TParamsKeys<TParams>>(key: TKey, value: TParams[TKey]): void;
    /**
     * Get param value
     */
    /**
     * Get param value
     */
    get<TKey extends TParamsKeys<TParams>>(key: TKey): TParams[TKey];
    /**
     * Toggle on
     */
    /**
     * Toggle on
     */
    enable<TKey extends TParamsBool<TParams>>(key: TKey): void;
    /**
     * Toggle off
     */
    /**
     * Toggle off
     */
    disable<TKey extends TParamsBool<TParams>>(key: TKey): void;
    /**
     * Return key value
     */
    isEnabled: <TKey extends TParamsBool<TParams>>(key: TKey) => boolean;
    /**
     * Check value
     */
    is: <TKey extends keyof TParams>(key: TKey, value: any) => boolean;
    /**
     * Increase param
     */
    /**
     * Increase param
     */
    increase<TKey extends TParamsInt<TParams>>(key: TKey): void;
    /**
     * Increase decrease
     */
    /**
     * Increase decrease
     */
    decrease<TKey extends TParamsInt<TParams>>(key: TKey): void;
}
export { ConfigStore as default };
