import { defineProperty as _defineProperty, createClass as _createClass, classCallCheck as _classCallCheck } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { makeObservable, observable, action } from 'mobx';

/**
 * Storage for global application parameters
 */
var ConfigStore = /*#__PURE__*/function () {
  /**
   * @constructor
   */
  function ConfigStore() {
    var _this = this;
    _classCallCheck(this, ConfigStore);
    /**
     * State
     */
    _defineProperty(this, "params", void 0);
    /**
     * Return key value
     */
    // @ts-ignore
    _defineProperty(this, "isEnabled", function (key) {
      return _this.params[key];
    });
    /**
     * Check value
     */
    _defineProperty(this, "is", function (key, value) {
      return _this.params[key] === value;
    });
    makeObservable(this, {
      params: observable,
      set: action.bound,
      enable: action.bound,
      disable: action.bound,
      increase: action.bound,
      decrease: action.bound
    });
  }
  /**
   * Set value of key
   */
  _createClass(ConfigStore, [{
    key: "set",
    value: function set(key, value) {
      this.params[key] = value;
    }
    /**
     * Get param value
     */
  }, {
    key: "get",
    value: function get(key) {
      return this.params[key];
    }
    /**
     * Toggle on
     */
  }, {
    key: "enable",
    value: function enable(key) {
      // @ts-ignore
      this.params[key] = true;
    }
    /**
     * Toggle off
     */
  }, {
    key: "disable",
    value: function disable(key) {
      // @ts-ignore
      this.params[key] = false;
    }
  }, {
    key: "increase",
    value:
    /**
     * Increase param
     */
    function increase(key) {
      // @ts-ignore
      this.params[key] += 1;
    }
    /**
     * Increase decrease
     */
  }, {
    key: "decrease",
    value: function decrease(key) {
      // @ts-ignore
      this.params[key] -= 1;
    }
  }]);
  return ConfigStore;
}();
_defineProperty(ConfigStore, "isGlobal", true);

export { ConfigStore as default };
//# sourceMappingURL=index.js.map
