import { createClass as _createClass, classCallCheck as _classCallCheck, defineProperty as _defineProperty } from '../../_virtual/_rollupPluginBabelHelpers.js';
import { makeObservable, observable, action } from 'mobx';

/**
 * Simple switch store
 */
var SwitchStore = /*#__PURE__*/function () {
  /**
   * @constructor
   */
  function SwitchStore() {
    _classCallCheck(this, SwitchStore);
    /**
     * State
     */
    _defineProperty(this, "isVisible", false);
    makeObservable(this, {
      isVisible: observable,
      onOpen: action.bound,
      onClose: action.bound
    });
  }
  /**
   * Open
   */
  _createClass(SwitchStore, [{
    key: "onOpen",
    value: function onOpen() {
      this.isVisible = true;
    }
    /**
     * Close
     */
  }, {
    key: "onClose",
    value: function onClose() {
      this.isVisible = false;
    }
    /**
     * Toggle
     */
  }, {
    key: "onToggle",
    value: function onToggle() {
      this.isVisible = !this.isVisible;
    }
  }]);
  return SwitchStore;
}();

export { SwitchStore as default };
//# sourceMappingURL=index.js.map
